package com.moyoung.moyoung_ble_plugin.event;


import android.util.Log;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.ota.hs.HsDfuController;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.method.OTAController;
import com.moyoung.moyoung_ble_plugin.model.OTABean;

import io.flutter.plugin.common.MethodCall;

public class FileFirmwareUpgradeHandler extends BaseConnectionEventChannelHandler {
    private static final FileFirmwareUpgradeHandler instance = new FileFirmwareUpgradeHandler();
    public static FileFirmwareUpgradeHandler getInstance() {
        return instance;
    }

    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        if (eventSink == null) {
            return;
        }
        String jsonStr = call.argument("otaBean");
        OTABean otaBean = GsonUtils.get().fromJson(jsonStr,
                OTABean.class);
        connection.startFirmwareUpgrade(otaBean.getType()==OTAController.START_OTA, new FirmwareUpgradeListener(eventSink));
    }

    public void setHsLazyConnListener(MethodCall call) {
        if (eventSink == null) {
            return;
        }
        String jsonStr = call.argument("otaBean");
        OTABean otaBean = GsonUtils.get().fromJson(jsonStr,
                OTABean.class);
        if (otaBean.getAddress() != null) {
            HsDfuController hsDfuController = HsDfuController.getInstance();
            hsDfuController.setUpgradeListener(new FirmwareUpgradeListener(eventSink));
            hsDfuController.setAddress(otaBean.getAddress());
            hsDfuController.start(true);
        }
    }

    public void setRtkUpgradeListener(MethodCall call) {
        if (eventSink == null) {
            return;
        }
        String jsonStr = call.argument("otaBean");
        OTABean otaBean = GsonUtils.get().fromJson(jsonStr,
                OTABean.class);
    }
}

